// ===========================================================================
//	COutOfContextApp.h					1999 Eric Traut
// ===========================================================================

#pragma once

#include <PP_Prefix.h>
#include <LApplication.h>

#include <Events.h>

class CShadowWindow;

class COutOfContextApp : public PP_PowerPlant::LApplication
{
	public:
		COutOfContextApp(void);

		virtual
		~COutOfContextApp(void);
	
		virtual Boolean
		ObeyCommand(	PP_PowerPlant::CommandT 	inCommand, 
						void * 						ioParam);	

		virtual void
		FindCommandStatus(	PP_PowerPlant::CommandT 	inCommand,
							Boolean &					outEnabled, 
							Boolean &					outUsesMark,
							PP_PowerPlant::Char16 &		outMark, 
							Str255 						outName);
		
		virtual Boolean
		AttemptQuitSelf(	SInt32	inSaveOption);
		
		void
		TearDownApp(void);
		
		static void
		OutOfContextTearDownProc(void);
		
		CShadowWindow *
		LookUpShadowWindow(	CWindowRecord *		inMacWindow);
		
		void
		GiveShadowWindowsTime(Boolean inGNETime);

		static THz
		GetAppHeap(void)
		{
			return sAppZone;
		}
		
		static COutOfContextApp *			sOutOfContextApp;
		
	protected:
		static void
		InstallWNEPatch(void);

		static void
		DeinstallWNEPatch(void);

		void
		TearDownShadowWindows(void);

		virtual void
		StartUp(void);

		void
		InstallGNEFilter(void);

		void
		RemoveGNEFilter(void);
	
		void
		HandleContextualMenuClick(	EventRecord *		ioEvent, 
									Boolean *			ioResult);

		void
		DoFinderGNEFilter(	EventRecord *		ioEvent, 
							Boolean *			ioResult);
		
		static pascal void
		GNEFilterPatch(		EventRecord *		ioEvent, 
							Boolean *			ioResult);

		void
		Flush68KCodeCache(void);

		void
		UpdateShadowWindowList(void);

		CShadowWindow *
		LookUpWindowInShadowList(	const CWindowRecord *		inMacWindow);

	private:
		TArray<CShadowWindow *>				mShadowWindowList;
		
		static GetNextEventFilterUPP		sChainedGNEFilter;
		static GetNextEventFilterUPP		sNewGNEFilter;
		static Ptr							sGNEJumpIsland;
		static Boolean						sGNEPatchInstalled;
		static THz							sAppZone;
		static Boolean						sWNEPatchInstalled;
		static Handle						sWNEPatchHandle;
		static MenuHandle					sContextMenu1;
		static MenuHandle					sContextMenu2;
		static SndChannelPtr				sSoundChannel;
};






