// ===========================================================================
//	CRebootBehavior.h 				1999 Eric Traut
// ===========================================================================

#pragma once

#include "COffscreenBehavior.h"


typedef UInt16	RebootState;
enum
{
	kRebootStateBlackScreen		= 0,
	kRebootStateBootBeep,
	kRebootStateGrayScreen,
	kRebootStateHappyMac,
	kRebootStateMacOSScreen,
	kRebootStateInit,
	kRebootStateTearDown
};

enum
{
	kTotalINITIcons				= 5
};

class CRebootBehavior : public COffscreenBehavior
{
	public:
		CRebootBehavior(CShadowWindow &		inShadowWindow);

		virtual Boolean
		RenderToGWorld(	StGWorldLocker &		inRenderingLocker);

		virtual void
		DoIdleTask(	Boolean 	inGNETime);

		UInt32
		GetTicksForState(RebootState inState);
		
		static void
		Initialize(	SndChannelPtr inSoundChannel);
		
	protected:
		void
		DrawMacOSScreen(	ConstStr255Param	inMsgString,
							UInt32				inTicksSinceStart,
							UInt32				inINITsToDraw);

		void
		CenterRect(		const Rect &		inBounds,
						Rect &				outCenterRect,
						SInt16				inBoxWidth,
						SInt16				inBoxHeight);

	private:
		RebootState					mCurRebootState;
		UInt32						mTicksInState;
		UInt32						mTicksStateStarted;
		
		static PixPatHandle			sBackgroundPixPat;
		static PicHandle			sMacOSPicture;
		static PicHandle			sProgressPicture;
		static PicHandle			sSliderPicture;
		static CIconHandle			sHappyMacIcon;
		static IconSuiteRef			sInitIcons[kTotalINITIcons];
		static SndListHandle		sBootBeepSound;
		static SndChannelPtr		sSndChannel;
};



